> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Operator effectiveness

This endpoint returns a bunch of useful information on the historical performance of a single operator. This includes rewards (aggregate and granular), performance (effectiveness and its components), slashing history and much more. For a glossary of the variables returned see [effectiveness](/rated-api/glossary/ethereum/effectiveness).

Here's how to interpret the inputs required to operate it 👇

| Parameter     | Context                                                                                                                                                                                                                                                                                                                           |
| :------------ | :-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `filterType`  | hour, day and datetime                                                                                                                                                                                                                                                                                                            |
| `from`        | Start day (integer) or datetime (e.g. from="2022-12-01")                                                                                                                                                                                                                                                                          |
| `granularity` | The size of time increments you are looking to query. Can be `day` / `week` / `month` / `quarter` / `year`.                                                                                                                                                                                                                       |
| `size`        | The number of results included per page                                                                                                                                                                                                                                                                                           |
| `idType`      | The type of entity class you would like returned. You might ask for `pool`, `poolShare`, `nodeOperator`, `depositAddress`, or `withdrawalAddress`. Note: it is optional and can be inferred automatically for pools, pool shares and node operators. It defaults to `depositAddress` if it is missing and an address is provided. |
| `include`     | A list of field names. Use it to filter the specific fields you want in the response payload                                                                                                                                                                                                                                      |


## OpenAPI

````yaml get /v0/eth/operators/{operator_id}/effectiveness
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v0/eth/operators/{operator_id}/effectiveness:
    get:
      tags:
        - Operators
      summary: Get Effectiveness
      operationId: get_effectiveness_v0_eth_operators__operator_id__effectiveness_get
      parameters:
        - name: operator_id
          in: path
          required: true
          schema:
            type: string
            title: Operator Id
        - name: idType
          in: query
          required: false
          schema:
            anyOf:
              - $ref: '#/components/schemas/IdType'
              - type: 'null'
            title: Idtype
        - name: from
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
                minimum: 0
              - type: string
                format: date
            title: From
        - name: size
          in: query
          required: false
          schema:
            type: integer
            default: 10
            title: Size
        - name: granularity
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/GranularityEnum'
            default: day
        - name: filterType
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/FilterTypeEnum'
        - name: include
          in: query
          required: false
          schema:
            anyOf:
              - items:
                  type: string
                type: array
              - type: 'null'
            title: Include
        - name: X-Rated-Network
          in: header
          required: false
          schema:
            $ref: '#/components/schemas/Network'
            default: mainnet
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedOperatorEffectiveness'
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    IdType:
      type: string
      enum:
        - depositAddress
        - withdrawalAddress
        - nodeOperator
        - pool
        - poolShare
        - entity
        - validator
        - privateSet
      title: IdType
    GranularityEnum:
      type: string
      enum:
        - hour
        - day
        - week
        - month
        - quarter
        - year
        - all
      title: GranularityEnum
    FilterTypeEnum:
      type: string
      enum:
        - hour
        - day
        - datetime
      title: FilterTypeEnum
    Network:
      type: string
      enum:
        - mainnet
        - hoodi
        - holesky
      title: Network
    PaginatedOperatorEffectiveness:
      properties:
        page:
          $ref: '#/components/schemas/api__schemas__page__Page'
        total:
          type: integer
          minimum: 0
          title: Total
        data:
          items:
            $ref: '#/components/schemas/OperatorEffectiveness'
          type: array
          title: Data
        next:
          anyOf:
            - type: string
            - type: 'null'
          title: Next
      type: object
      required:
        - page
        - total
        - data
        - next
      title: PaginatedOperatorEffectiveness
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    api__schemas__page__Page:
      properties:
        from:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: From
        to:
          anyOf:
            - type: integer
            - type: string
              format: date
            - type: 'null'
          title: To
        size:
          type: integer
          exclusiveMinimum: 0
          title: Size
          default: 10
        granularity:
          anyOf:
            - $ref: '#/components/schemas/GranularityEnum'
            - type: 'null'
        filterType:
          anyOf:
            - $ref: '#/components/schemas/FilterTypeEnum'
            - type: 'null'
      type: object
      title: Page
    OperatorEffectiveness:
      properties:
        hour:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Hour
        day:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Day
        startDay:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Startday
        endDay:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Endday
        id:
          type: string
          title: Id
        idType:
          $ref: '#/components/schemas/IdType'
        validatorCount:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Validatorcount
        avgInclusionDelay:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Avginclusiondelay
        avgUptime:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Avguptime
        avgCorrectness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Avgcorrectness
        avgProposerEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Avgproposereffectiveness
        avgValidatorEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Avgvalidatoreffectiveness
        totalUniqueAttestations:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Totaluniqueattestations
        sumCorrectHead:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumcorrecthead
        sumCorrectTarget:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumcorrecttarget
        sumInclusionDelay:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Suminclusiondelay
        sumProposedCount:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumproposedcount
        sumProposerDutiesCount:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumproposerdutiescount
        slashesCollected:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Slashescollected
        slashesReceived:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Slashesreceived
        sumEarnings:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumearnings
        sumEstimatedRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumestimatedrewards
        sumEstimatedPenalties:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumestimatedpenalties
        networkPenetration:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Networkpenetration
        sumPriorityFees:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumpriorityfees
        sumBaselineMev:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumbaselinemev
        sumMissedExecutionRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Summissedexecutionrewards
        sumConsensusBlockRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumconsensusblockrewards
        sumMissedConsensusBlockRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Summissedconsensusblockrewards
        sumAllRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumallrewards
        sumCorrectSource:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumcorrectsource
        avgAttesterEffectiveness:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Avgattestereffectiveness
        sumMissedSyncSignatures:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Summissedsyncsignatures
        sumSyncCommitteePenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumsynccommitteepenalties
        sumLateSourceVotes:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumlatesourcevotes
        sumWrongTargetVotes:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumwrongtargetvotes
        sumLateTargetVotes:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumlatetargetvotes
        sumWrongTargetPenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumwrongtargetpenalties
        sumLateTargetPenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumlatetargetpenalties
        sumMissedAttestations:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Summissedattestations
        sumMissedAttestationPenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Summissedattestationpenalties
        sumWrongHeadVotes:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumwrongheadvotes
        sumWrongHeadPenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumwrongheadpenalties
        sumAttestationRewards:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Sumattestationrewards
        sumLateSourcePenalties:
          anyOf:
            - type: number
            - type: 'null'
          title: Sumlatesourcepenalties
        sumExecutionProposedEmptyCount:
          anyOf:
            - type: integer
              minimum: 0
            - type: 'null'
          title: Sumexecutionproposedemptycount
        sumMissedAttestationRewards:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Summissedattestationrewards
        sumMissedSyncCommitteeRewards:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Summissedsynccommitteerewards
        sumExternallySourcedExecutionRewards:
          anyOf:
            - type: integer
            - type: 'null'
          title: Sumexternallysourcedexecutionrewards
        sumEndEpochBalance:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Sumendepochbalance
        sumEndEpochEffectiveBalance:
          anyOf:
            - type: number
              minimum: 0
            - type: 'null'
          title: Sumendepocheffectivebalance
        startEpoch:
          type: integer
          minimum: 0
          title: Startepoch
          readOnly: true
        endEpoch:
          type: integer
          minimum: 0
          title: Endepoch
          readOnly: true
      type: object
      required:
        - id
        - idType
        - validatorCount
        - avgInclusionDelay
        - avgUptime
        - avgCorrectness
        - avgProposerEffectiveness
        - avgValidatorEffectiveness
        - totalUniqueAttestations
        - sumCorrectHead
        - sumCorrectTarget
        - sumInclusionDelay
        - sumProposedCount
        - sumProposerDutiesCount
        - slashesCollected
        - slashesReceived
        - sumEarnings
        - sumEstimatedRewards
        - sumEstimatedPenalties
        - networkPenetration
        - sumPriorityFees
        - sumBaselineMev
        - sumMissedExecutionRewards
        - sumConsensusBlockRewards
        - sumMissedConsensusBlockRewards
        - sumAllRewards
        - sumCorrectSource
        - avgAttesterEffectiveness
        - sumMissedSyncSignatures
        - sumSyncCommitteePenalties
        - sumLateSourceVotes
        - sumWrongTargetVotes
        - sumLateTargetVotes
        - sumWrongTargetPenalties
        - sumLateTargetPenalties
        - sumMissedAttestations
        - sumMissedAttestationPenalties
        - sumWrongHeadVotes
        - sumWrongHeadPenalties
        - sumAttestationRewards
        - sumLateSourcePenalties
        - sumExecutionProposedEmptyCount
        - sumMissedAttestationRewards
        - sumMissedSyncCommitteeRewards
        - sumExternallySourcedExecutionRewards
        - sumEndEpochBalance
        - sumEndEpochEffectiveBalance
        - startEpoch
        - endEpoch
      title: OperatorEffectiveness
      examples:
        - avgAttesterEffectiveness: 97.9580945527236
          avgCorrectness: 0.9929917401071404
          avgInclusionDelay: 1.0138705386457403
          avgProposerEffectiveness: 99.53271028037379
          avgUptime: 0.9999466390184881
          avgValidatorEffectiveness: 97.96642775943795
          day: 796
          endEpoch: 179100
          id: Stakefish
          idType: nodeOperator
          networkPenetration: 0.03132911454080191
          slashesCollected: 0
          slashesReceived: 0
          startEpoch: 179324
          sumAllRewards: 72694727007
          sumAttestationRewards: 50120815885
          sumBaselineMev: 5266131924
          sumConsensusBlockRewards: 6554423259
          sumCorrectHead: 3547355
          sumCorrectSource: 3614403
          sumCorrectTarget: 3612248
          sumEarnings: 56766373292
          sumEndEpochBalance: 32000000000000000000
          sumEndEpochEffectiveBalance: 32000000000000000000
          sumEstimatedPenalties: -82967688
          sumEstimatedRewards: 56675239144
          sumExecutionProposedEmptyCount: 0
          sumExternallySourcedExecutionRewards: 14862131536
          sumInclusionDelay: 3666847
          sumLateSourcePenalties: -7960547
          sumLateSourceVotes: 2279
          sumLateTargetPenalties: 0
          sumLateTargetVotes: 0
          sumMissedAttestationPenalties: -1926140
          sumMissedAttestationRewards: 269961427
          sumMissedAttestations: 193
          sumMissedConsensusBlockRewards: 31228533
          sumMissedExecutionRewards: 58181568
          sumMissedSyncCommitteeRewards: 44317643
          sumMissedSyncSignatures: 2837
          sumPriorityFees: 10662221791
          sumProposedCount: 213
          sumProposerDutiesCount: 214
          sumSyncCommitteePenalties: -44317643
          sumWrongHeadPenalties: 0
          sumWrongHeadVotes: 48767
          sumWrongTargetPenalties: -28763358
          sumWrongTargetVotes: 4434
          totalUniqueAttestations: 3616682
          validatorCount: 16075
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````